<?php

/**
 * Returns true if in cli mode
 */
function is_cli() {
    return php_sapi_name() === 'cli';
}

/**
 * Convenience function that outputs an HTTP status code
 * @param $code integer HTTP status code
 * @return string HTTP status code's name
 */
function set_response_code($code) {
    $php = XHTMLCompiler::getPHPWrapper();
    $code_descriptions = array( // could be factored out
        200 => 'Okay',
        304 => 'Not Modified',
        401 => 'Unauthorized',
        403 => 'Forbidden',
        404 => 'Not Found',
        500 => 'Internal Server Error',
        503 => 'Service Unavailable',
    );
    $code = (int) $code; // enforce integer
    $text = (string) $code;
    if (isset($code_descriptions[$code])) {
        $text .= ' ' . $code_descriptions[$code];
    }
    if (isset($_SERVER['SERVER_PROTOCOL'])) {
        $php->header($_SERVER['SERVER_PROTOCOL'] . ' ' . $text, true, $code);
        $php->header('Status: ' . $text);
    }
    return $text;
}

/**
 * Determines the requested page from server environment files
 * @return string page name
 */
function get_page_from_server() {
    $php = XHTMLCompiler::getPHPWrapper();
    // load up page from environment variables, if using ErrorDocument impl.
    $page = $php->getRequestURI();
    $self = dirname($php->getPHPSelf());
    $root = strlen(substr($self, 0, strrpos($self, '/')));
    $page = substr($page, $root + 1); // remove leading slash and root
    return $page;
}

/**
 * Determines the requested page from get parameter
 * @return string page name
 */
function get_page_from_get() {
    $php = XHTMLCompiler::getPHPWrapper();
    return $php->getGVal('f');
}

/**
 * Takes a page name and appends index filename if necessary
 * @param $page string page name
 * @param $directory_index string name of file to use as directory index
 */
function normalize_index($page, $directory_index) {
    $php = XHTMLCompiler::getPHPWrapper();
    if ($page == '') $page = $directory_index;
    if ($php->isDir($page)) {
        if ($page[strlen($page)-1] !== '/') $page .= '/';
        $page .= $directory_index;
    }
    return $page;
}

/**
 * Determines whether or not an .html file was generated by us
 * @param $page filename of page, must exist
 */
function is_created_by_us($page) {
    $contents = file_get_contents($page);
    return (strpos($contents, '<!-- generated by XHTML Compiler -->') !== false);
}

/**
 * Exception handler, prints a pretty HTTP error message
 * @param $e The uncaught exception
 * @todo Augment debug mode to have stack traces
 * @todo Make more friendly to command-line
 */
function xhtmlcompiler_exception_handler(Exception $e) {
    $xc  = XHTMLCompiler::getInstance();
    $php = XHTMLCompiler::getPHPWrapper();

    if (is_cli()) {
        $php->paint((string) $e);
        return;
    }

    $error_xsl = $xc->getConf('error_xsl');

    // extract information out of exception
    if ($e instanceof XHTMLCompiler_Exception) {
        $code    = $e->getCode();
        $title    = $e->getMessage();
        $details = $e->getDetails();
    } else {
        $code = 500;
        $title = false;
        $details = $e->getMessage();
    }

    // send appropriate response code
    $default = set_response_code($code);

    // munge the title
    if (!$title) $title = $default;
    else $title = $code . ' ' . $title;

    // build a error document
    $page = new DOMDocument('1.0', 'utf-8');
    $error = $page->createElement('error'); $page->appendChild($error);
    $error->appendChild($page->createElement('code', $code));
    $error->appendChild($page->createElement('title', $title));
    $error->appendChild($page->createElement('base', $xc->getConf('web_path')));

    // details (in HTML)
    if ($details) {
        $html = $page->createDocumentFragment();
        $html->appendXML($details);
        $details_dom = $page->createElement('details');
        $details_dom->appendChild($html);
        $error->appendChild($details_dom);
    }

    // debug
    if ($xc->getConf('debug')) {
        $debug = $page->createElement('debug');
        $debug->appendChild($page->createElement('base-dir', $base = dirname(__FILE__)));
        $debug->appendChild($page->createElement('file', shortenFile($e->getFile(), $base)));
        $debug->appendChild($page->createElement('line', $e->getLine()));
        $error->appendChild($debug);
    }

    // generate and output html
    $xslt_processor = new ConfigDoc_HTMLXSLTProcessor();
    $xslt_processor->importStylesheet(dirname(__FILE__) . '/../' . $error_xsl);
    $html = $xslt_processor->transformToHTML($page);
    $php->paint($html);

}


/** Returns short filename based on a base directory */
function shortenFile($file, $base) {
    if (strpos($file, $base) === 0) {
        $file = str_replace('\\', '/', substr($file, strlen($base)));
        if ($file === '') $file = '.';
        if ($file[0] === '/') $file = substr($file, 1);
    }
    return $file;
}

/**
 * Checks for errors, and sends a notification email if necessary
 */
function check_errors() {
    $xc = XHTMLCompiler::getInstance();
    $error_log = $xc->getConf('error_log');
    $error_mute = $xc->getConf('error_mute');
    if (file_exists($error_log) && filesize($error_log) > 0) {
        if (file_exists($error_mute) && filesize($error_mute) == 0) {
            $error_text = wordwrap(file_get_contents($error_log), 70, "\r\n");
            try {
                $message = Swift_Message::newInstance()
                    ->setSubject('Errors in XHTML Compiler')
                    ->setTo($xc->getConf('admin_email'))
                    ->setFrom($xc->getConf('from_email'))
                    ->setBody(<<<BODY
Some errors occured in the log. No further messages
will be sent until the mute file [1] is deleted. The
error log file [2] will be blanked after resolving any
issues.

[1] $error_mute
[2] $error_log

$error_text
BODY
);
                $xc->getConf('smtp_transport')->send($message);
            } catch (Exception $e) {
                // uh oh, mail failed, not much we can do about that.
                if ($xc->getConf('debug')) {
                    echo $e . "\n";
                }
            }
            file_put_contents($error_mute, '1');
        } elseif (!file_exists($error_mute) && file_exists($error_log)) {
            $tentative_new_name = "$error_log." . date('Ymd');
            $i = 0;
            $new_name = $tentative_new_name;
            while (file_exists($tentative_new_name) && file_exists($new_name)) {
                $new_name = "$tentative_new_name-$i";
                $i++;
            }
            copy($error_log, $new_name);
            file_put_contents($error_log, '');
            file_put_contents($error_mute, '');
        }
    }
}
